/*
 * Npcf_SMPolicyControl
 *
 * Session Management Policy Control Service
 *
 * API version: 1.0.1
 * Generated by: OpenAPI Generator (https://openapi-generator.tech)
 */

package models

import (
	"time"
)

type SmPolicyUpdateContextData struct {
	// The policy control reqeust trigges which are met.
	RepPolicyCtrlReqTriggers []PolicyControlRequestTrigger `json:"repPolicyCtrlReqTriggers,omitempty" yaml:"repPolicyCtrlReqTriggers" bson:"repPolicyCtrlReqTriggers" mapstructure:"RepPolicyCtrlReqTriggers"`
	// Indicates the access network charging identifier for the PCC rule(s) or whole PDU session.
	AccNetChIds          []AccNetChId          `json:"accNetChIds,omitempty" yaml:"accNetChIds" bson:"accNetChIds" mapstructure:"AccNetChIds"`
	AccessType           AccessType            `json:"accessType,omitempty" yaml:"accessType" bson:"accessType" mapstructure:"AccessType"`
	RatType              RatType               `json:"ratType,omitempty" yaml:"ratType" bson:"ratType" mapstructure:"RatType"`
	ServingNetwork       *NetworkId            `json:"servingNetwork,omitempty" yaml:"servingNetwork" bson:"servingNetwork" mapstructure:"ServingNetwork"`
	UserLocationInfo     *UserLocation         `json:"userLocationInfo,omitempty" yaml:"userLocationInfo" bson:"userLocationInfo" mapstructure:"UserLocationInfo"`
	UeTimeZone           string                `json:"ueTimeZone,omitempty" yaml:"ueTimeZone" bson:"ueTimeZone" mapstructure:"UeTimeZone"`
	RelIpv4Address       string                `json:"relIpv4Address,omitempty" yaml:"relIpv4Address" bson:"relIpv4Address" mapstructure:"RelIpv4Address"`
	Ipv4Address          string                `json:"ipv4Address,omitempty" yaml:"ipv4Address" bson:"ipv4Address" mapstructure:"Ipv4Address"`
	Ipv6AddressPrefix    string                `json:"ipv6AddressPrefix,omitempty" yaml:"ipv6AddressPrefix" bson:"ipv6AddressPrefix" mapstructure:"Ipv6AddressPrefix"`
	RelIpv6AddressPrefix string                `json:"relIpv6AddressPrefix,omitempty" yaml:"relIpv6AddressPrefix" bson:"relIpv6AddressPrefix" mapstructure:"RelIpv6AddressPrefix"`
	RelUeMac             string                `json:"relUeMac,omitempty" yaml:"relUeMac" bson:"relUeMac" mapstructure:"RelUeMac"`
	UeMac                string                `json:"ueMac,omitempty" yaml:"ueMac" bson:"ueMac" mapstructure:"UeMac"`
	SubsSessAmbr         *Ambr                 `json:"subsSessAmbr,omitempty" yaml:"subsSessAmbr" bson:"subsSessAmbr" mapstructure:"SubsSessAmbr"`
	SubsDefQos           *SubscribedDefaultQos `json:"subsDefQos,omitempty" yaml:"subsDefQos" bson:"subsDefQos" mapstructure:"SubsDefQos"`
	// Contains the number of supported packet filter for signalled QoS rules.
	NumOfPackFilter int32 `json:"numOfPackFilter,omitempty" yaml:"numOfPackFilter" bson:"numOfPackFilter" mapstructure:"NumOfPackFilter"`
	// Contains the usage report
	AccuUsageReports []AccuUsageReport `json:"accuUsageReports,omitempty" yaml:"accuUsageReports" bson:"accuUsageReports" mapstructure:"AccuUsageReports"`
	// If it is included and set to true, the 3GPP PS Data Off is activated by the UE.
	Var3gppPsDataOffStatus bool `json:"3gppPsDataOffStatus,omitempty" yaml:"3gppPsDataOffStatus" bson:"3gppPsDataOffStatus" mapstructure:"Var3gppPsDataOffStatus"`
	// Report the start/stop of the application traffic and detected SDF descriptions if applicable.
	AppDetectionInfos []AppDetectionInfo `json:"appDetectionInfos,omitempty" yaml:"appDetectionInfos" bson:"appDetectionInfos" mapstructure:"AppDetectionInfos"`
	// Used to report the PCC rule failure.
	RuleReports []RuleReport `json:"ruleReports,omitempty" yaml:"ruleReports" bson:"ruleReports" mapstructure:"RuleReports"`
	// QoS Notification Control information.
	QncReports           []QosNotificationControlInfo `json:"qncReports,omitempty" yaml:"qncReports" bson:"qncReports" mapstructure:"QncReports"`
	UserLocationInfoTime *time.Time                   `json:"userLocationInfoTime,omitempty" yaml:"userLocationInfoTime" bson:"userLocationInfoTime" mapstructure:"UserLocationInfoTime"`
	// Reports the changes of presence reporting area.
	RepPraInfos  map[string]PresenceInfo     `json:"repPraInfos,omitempty" yaml:"repPraInfos" bson:"repPraInfos" mapstructure:"RepPraInfos"`
	UeInitResReq *UeInitiatedResourceRequest `json:"ueInitResReq,omitempty" yaml:"ueInitResReq" bson:"ueInitResReq" mapstructure:"UeInitResReq"`
	// If it is included and set to true, the reflective QoS is supported by the UE. If it is included and set to false, the reflective QoS is revoked by the UE.
	RefQosIndication   bool                   `json:"refQosIndication,omitempty" yaml:"refQosIndication" bson:"refQosIndication" mapstructure:"RefQosIndication"`
	QosFlowUsage       QosFlowUsage           `json:"qosFlowUsage,omitempty" yaml:"qosFlowUsage" bson:"qosFlowUsage" mapstructure:"QosFlowUsage"`
	CreditManageStatus CreditManagementStatus `json:"creditManageStatus,omitempty" yaml:"creditManageStatus" bson:"creditManageStatus" mapstructure:"CreditManageStatus"`
	ServNfId           *ServingNfIdentity     `json:"servNfId,omitempty" yaml:"servNfId" bson:"servNfId" mapstructure:"ServNfId"`
	TraceReq           *TraceData             `json:"traceReq,omitempty" yaml:"traceReq" bson:"traceReq" mapstructure:"TraceReq"`
}
