/*
 * Nudr_DataRepository API OpenAPI file
 *
 * Unified Data Repository Service
 *
 * API version: 1.0.0
 * Generated by: OpenAPI Generator (https://openapi-generator.tech)
 */

package models

import (
	"time"
)

type TrafficInfluDataPatch struct {
	// Contains the Notification Correlation Id allocated by the NEF for the UP path change notification.
	UpPathChgNotifCorreId string `json:"upPathChgNotifCorreId,omitempty" bson:"upPathChgNotifCorreId"`
	// Identifies whether an application can be relocated once a location of the application has been selected.
	AppReloInd bool   `json:"appReloInd,omitempty" bson:"appReloInd"`
	Dnn        string `json:"dnn,omitempty" bson:"dnn"`
	// Identifies Ethernet packet filters.Either \"trafficFilters\" or \"ethTrafficFilters\" shall be included if applicable.
	EthTrafficFilters []EthFlowDescription `json:"ethTrafficFilters,omitempty" bson:"ethTrafficFilters"`
	Snssai            *Snssai              `json:"snssai,omitempty" bson:"snssai"`
	// Identifies a group of users.
	InternalGroupId string `json:"internalGroupId,omitempty" bson:"internalGroupId"`
	Supi            string `json:"supi,omitempty" bson:"supi"`
	// Identifies IP packet filters.Either \"trafficFilters\" or \"ethTrafficFilters\" shall be included if applicable.
	TrafficFilters []FlowInfo `json:"trafficFilters,omitempty" bson:"trafficFilters"`
	// Identifies the N6 traffic routing requirement.
	TrafficRoutes  []RouteToLocation `json:"trafficRoutes,omitempty" bson:"trafficRoutes"`
	ValidStartTime *time.Time        `json:"validStartTime,omitempty" bson:"validStartTime"`
	ValidEndTime   *time.Time        `json:"validEndTime,omitempty" bson:"validEndTime"`
	NwAreaInfo     *NetworkAreaInfo  `json:"nwAreaInfo,omitempty" bson:"nwAreaInfo"`
	// string providing an URI formatted according to IETF RFC 3986.
	UpPathChgNotifUri string `json:"upPathChgNotifUri,omitempty" bson:"upPathChgNotifUri"`
}
